"use strict";
var tsc = require('typescript');
var path = require('path');
function getTSConfig(globals) {
    var config = (globals && globals.__TS_CONFIG__) ? globals.__TS_CONFIG__ : undefined;
    if (config === undefined) {
        config = 'tsconfig.json';
    }
    if (typeof config === 'string') {
        config = require(path.resolve(config)).compilerOptions;
    }
    config.module = config.module || tsc.ModuleKind.CommonJS;
    config.jsx = config.jsx || tsc.JsxEmit.React;
    return tsc.convertCompilerOptionsFromJson(config, undefined).options;
}
exports.getTSConfig = getTSConfig;
